! module with the dynamical equations
module hamiltonian

  use parameters
  
  implicit none

contains

!***************************************************************************************

  ! right-hand side of the equations of motion of the Kepler problem
  function DHam(p,x)

     implicit none

     type(hamparam),intent(in):: p
     double precision,intent(in):: x(4)
     double precision:: DHam(4)

     double precision:: r1,r2,y(2)

     !-----------------------------------------------
     ! P3-P1
     y(1) = x(1) + p%mu
     y(2) = x(2)
     r1 = sqrt(DOT_PRODUCT(y(1:2),y(1:2)))
     ! P3-P2
     y(1) = x(1) - (1.d0 - p%mu)
     y(2) = x(2)
     r2 = sqrt(DOT_PRODUCT(y(1:2),y(1:2)))
     ! velocity
     DHam(1:2) = x(3:4)
     ! acceleration
     DHam(3) =   2.d0*x(4) + x(1) - (1.d0-p%mu)*(x(1)+p%mu)/r1**3 - p%mu*(x(1)-1.d0+p%mu)/r2**3 
     DHam(4) = - 2.d0*x(3) + x(2) - (1.d0-p%mu)*x(2)/r1**3 - p%mu*x(2)/r2**3 

  end function DHam

!***************************************************************************************

end module hamiltonian
